-Removed all ipkg_* functions and replaced them with a single ipkg function accepting...
[hvlinux.git] / functions
index a986466..9c863ea 100644 (file)
--- a/functions
+++ b/functions
@@ -1,4 +1,4 @@
-#!/bin/sh
+#!/bin/bash
 # This file is 'sourced' by other scripts, therefore the above line is of no
 # use, except when modifying the file in emacs to have syntax highlighting.
 
@@ -7,22 +7,82 @@ EXIT_SUCCESS=0
 EXIT_WARNING=1
 EXIT_FAILURE=2
 
-# The starting position for displaying the "X" sign inside the check box [ ]
-CHECK_POSITION=2
-SET_CHECK_POSITION="echo -en \\033[${CHECK_POSITION}G"
-
+# Position the cursor at the start of the line
+SET_CURSOR_START_LINE="\033[1G"
 # NORMAL prints text in normal color
-NORMAL="echo -en \\033[0;39m"
+NORMAL="\033[0;39m"
 # SUCCESS prints text in a green colour
-SUCCESS="echo -en \\033[1;32m"
+SUCCESS="\033[1;32m"
 # WARNING prints text in a yellow colour
-WARNING="echo -en \\033[1;33m"
+WARNING="\033[1;33m"
 # FAILURE prints text in a red colour
-FAILURE="echo -en \\033[1;31m"
+FAILURE="\033[1;31m"
+# Brackets are blue
+BRACKET="\033[1;34m"
+
+TAR_OPTS="-b8"
+
+HV_FONTS_PATH="/usr/share/fonts"
+
+DEFAULT_EDITOR=nano
+
+# It seems that when compiling bash-4.0, using
+# "make -j 1" is causing problems...
+if [ "x${MAKEJOBS}" = "x1" ]; then
+    HVMAKE="make"
+else
+    HVMAKE="make -j ${MAKEJOBS}"
+fi
+
+case "${HVL_TARGET}" in
+    arm*)
+        CLFS_BUILDFLAGS="-mabi=aapcs-linux -mfloat-abi=soft"
+        CLFS_TARGET="arm-linux-gnueabi"
+        CLFS_ARCH=$(echo ${CLFS_TARGET} | sed -e 's/-.*//' -e 's/arm.*/arm/g')
+        CLFS_ENDIAN=$(echo ${CLFS_ARCH} | sed -e 's/armeb/BIG/' -e 's/arm/LITTLE/')
+        if [ "${CLFS_ENDIAN}" = "LITTLE" ]; then
+            CLFS_NOT_ENDIAN="BIG"
+        else
+            CLFS_NOT_ENDIAN="LITTLE"
+        fi
+       ;;
+    "x86_64")
+       CLFS_BUILDFLAGS="-m64"
+        CLFS_TARGET="${HVL_TARGET}-unknown-linux-gnu"
+        CLFS_ARCH=${HVL_TARGET}
+       ;;
+    "x86")
+        # No special flags
+       CLFS_BUILDFLAGS=""
+        CLFS_TARGET="i686-unknown-linux-gnu"
+        CLFS_ARCH=${HVL_TARGET}
+       ;;
+    *)
+       echo "Unsupported target architecture: ${HVL_TARGET}"
+       return ${EXIT_FAILURE}
+       ;;
+esac
+
+CLFS_HOST="$(echo $MACHTYPE | \
+    sed "s/$(echo $MACHTYPE | cut -d- -f2)/cross/")"
 
+export CLFS_BUILDFLAGS CLFS_TARGET CLFS_ARCH CLFS_HOST CLFS_ENDIAN CLFS_NOT_ENDIAN
+
+CLFS=${LFS}
+
+function function_exists
+{
+    local FUNCTION_NAME=$1
+
+    [ -z "$FUNCTION_NAME" ] && return 1
+
+    declare -F "$FUNCTION_NAME" > /dev/null 2>&1
+
+    return $?
+}
 
 # Extracting the version number from a complete package name.
-# Arg. #1: Complete package name with version (ex: gcc-3.4.4 will output 3.4.4)
+# Arg. #1: Complete package name with version (ex: firefox-3.5.5.source will output 3.5.5)
 get_pkg_ver()
 {
     # Checking for correct number of arguments
@@ -31,10 +91,9 @@ get_pkg_ver()
        return 1
     fi
 
-    echo ${1} | sed "s!^.*-\(.*\)!\1!g"
+    echo ${1} | sed "s!.*-\([0-9].*\)!\1!g"
 }
 
-
 # Extracting the base version number from a complete package name.
 # Arg. #1: Complete package name with version (ex: gcc-3.4.4 will output 3.4)
 get_pkg_ver_base()
@@ -48,7 +107,6 @@ get_pkg_ver_base()
     echo ${1} | sed "s!^.*-\([0-9]*\.[0-9]*\).*!\1!g"
 }
 
-
 # Extracting the base version number from a complete package name.
 # Arg. #1: Complete package name with version (ex: gcc-3.4.4 will output 3)
 get_pkg_ver_major()
@@ -62,7 +120,6 @@ get_pkg_ver_major()
     echo ${1} | sed "s!^.*-\([0-9]*\)\..*!\1!g"
 }
 
-
 # Extracting the name from a complete package name.
 # Arg. #1: Complete package name with version (ex: gcc-3.4.4 will output gcc)
 get_pkg_name()
@@ -73,10 +130,12 @@ get_pkg_name()
        return 1
     fi
 
-    echo ${1} | sed "s!^\(.*\)-.*!\1!g"
+    # SED do not support non-greedy regexp:
+    # We want to match any characters preceeding a dash followed by a number
+    # (shortest match -> non-greedy)
+    echo ${1} | sed "s!\([^-][^0-9]*\)-[0-9].*!\1!"
 }
 
-
 # Saves the content of CFLAGS and CXXFLAGS environment variables.
 save_flags()
 {
@@ -86,7 +145,6 @@ save_flags()
     return ${EXIT_SUCCESS}
 }
 
-
 # Saves the content of CFLAGS and CXXFLAGS environment variables, and then
 # set them to empty strings.
 save_flags_no_optimizations()
@@ -99,7 +157,6 @@ save_flags_no_optimizations()
     return ${EXIT_SUCCESS}
 }
 
-
 # Restores the previous values of CFLAGS and CXXFLAGS environment variables. These
 # must have been saved first using save_flags().
 restore_flags()
@@ -110,7 +167,6 @@ restore_flags()
     return ${EXIT_SUCCESS}
 }
 
-
 # Create log directory and log file for current stage if necessary
 # This should be done automatically...
 init_log_file()
@@ -121,7 +177,6 @@ init_log_file()
     fi
 }
 
-
 # Create symbolic links for start/stop scripts in /etc/rc.d
 #
 # Arg #1: script name
@@ -138,8 +193,8 @@ static_bootscript_add()
     local START_LEVELS=""
     local STOP_LEVELS=""
 
-    if [ "x${RCLEVEL}" = "xS" ]; then
-       START_LEVELS="S"
+    if [ "x${RCLEVEL}" = "xsysinit" ]; then
+       START_LEVELS="sysinit"
        STOP_LEVELS="0 6"
     elif [ "x${RCLEVEL}" = "x3" ]; then
        START_LEVELS="3 4 5"
@@ -150,18 +205,18 @@ static_bootscript_add()
     fi
     
     # Making sure bootscript has correct permissions
-    chmod -v 740 /etc/rc.d/init.d/${SCRIPTNAME} &&
+    chmod -v 740 ${LFS}/etc/rc.d/init.d/${SCRIPTNAME} &&
 
     # Removing any old links
-    for level in S 0 1 2 3 4 5 6; do
-        cd /etc/rc.d/rc${level}.d &&
+    for level in sysinit 0 1 2 3 4 5 6; do
+        cd ${LFS}/etc/rc.d/rc${level}.d &&
        rm -v -f $(find . -name "???${SCRIPTNAME}") || exit 1
     done &&
 
     if [ ${START} -ne 0 ]; then
        # Creating new start links
        for level in ${START_LEVELS}; do
-           cd /etc/rc.d/rc${level}.d &&
+           cd ${LFS}/etc/rc.d/rc${level}.d &&
            ln -v -s ../init.d/${SCRIPTNAME} S${START}${SCRIPTNAME} || exit 1
        done
     fi &&
@@ -169,13 +224,12 @@ static_bootscript_add()
     if [ ${STOP} -ne 0 ]; then
        # Creating new stop links
        for level in ${STOP_LEVELS}; do
-           cd /etc/rc.d/rc${level}.d &&
+           cd ${LFS}/etc/rc.d/rc${level}.d &&
            ln -v -s ../init.d/${SCRIPTNAME} K${STOP}${SCRIPTNAME} || exit 1
        done
     fi
 }
 
-
 # Create symbolic links for start/stop scripts in /etc/rc.d
 #
 # Arg #1: level
@@ -190,26 +244,25 @@ bootscript_add_manual()
     local STOP=${4}
 
     # Making sure bootscript has correct permissions
-    chmod 740 /etc/rc.d/init.d/${SCRIPTNAME} &&
+    chmod 740 ${LFS}/etc/rc.d/init.d/${SCRIPTNAME} &&
 
     # Removing any old links
-    cd /etc/rc.d/rc${RCLEVEL}.d &&
+    cd ${LFS}/etc/rc.d/rc${RCLEVEL}.d &&
     rm -v -f $(find . -name "???${SCRIPTNAME}") &&
 
     if [ ${START} -ne 0 ]; then
        # Creating new start link
-       cd /etc/rc.d/rc${RCLEVEL}.d &&
+       cd ${LFS}/etc/rc.d/rc${RCLEVEL}.d &&
        ln -v -s ../init.d/${SCRIPTNAME} S${START}${SCRIPTNAME} || exit 1
     fi &&
 
     if [ ${STOP} -ne 0 ]; then
        # Creating new stop link
-       cd /etc/rc.d/rc${RCLEVEL}.d &&
+       cd ${LFS}/etc/rc.d/rc${RCLEVEL}.d &&
        ln -v -s ../init.d/${SCRIPTNAME} K${STOP}${SCRIPTNAME} || exit 1
     fi
 }
 
-
 # Create symbolic links for start/stop scripts in /etc/rc.d
 #
 # Arg #1: script name
@@ -220,18 +273,16 @@ bootscript_add_rc3()
     static_bootscript_add ${*} 3
 }
 
-
 # Create symbolic links for start/stop scripts in /etc/rc.d
 #
 # Arg #1: script name
 # Arg #2: start number
 # Arg #3: stop number
-bootscript_add_rcS()
+bootscript_add_rcsysinit()
 {
-    static_bootscript_add ${*} S
+    static_bootscript_add ${*} sysinit
 }
 
-
 # Add "export" before the variable name
 #
 # Arg #1: variable name
@@ -275,7 +326,6 @@ var_export()
     sed -i "s!\(^${VARIABLE}=.*\)!export \1!" ${FILE}
 }
 
-
 # Adding a new environment variable to a file.
 #
 # Arg #1: variable name
@@ -319,12 +369,11 @@ var_add()
     # PATH=... matches but not MANPATH=...
     if grep "^${VARIABLE}=\"" ${FILE} 1> /dev/null 2>&1; then
        # Variable value is enclosed by double-quotes
-       sed -i "s!\(^${VARIABLE}=\".*\)\(\"\)!\1${SEP}${VALUE}\"!" ${FILE}
+       sed -i "s!\(^${VARIABLE}=\".*\)\(\"\)!\1${SEP}${VALUE}\"!" ${FILE} || exit 1
     else
        # Variable value is NOT enclosed by double-quotes
-       sed -i "s!\(^${VARIABLE}=.*\)!\1${SEP}${VALUE}!" ${FILE}
+       sed -i "s!\(^${VARIABLE}=.*\)!\1${SEP}${VALUE}!" ${FILE} || exit 1
     fi
-    evaluate_retval
 
     # Adding new value to variable (case with export before)
     # We search for the variable name starting after an export statement,
@@ -342,7 +391,6 @@ var_add()
     return $?
 }
 
-
 # Adding a new path environment variable to a file.
 #
 # Arg #1: variable name
@@ -353,7 +401,6 @@ var_add_path()
     var_add ${1} ${2} "${3}" ":" 1>> ${LFS_LOG_FILE} 2>&1
 }
 
-
 # Adding a new string environment variable to a file.
 #
 # Arg #1: variable name
@@ -364,7 +411,6 @@ var_add_str()
     var_add ${1} ${2} "${3}" " "
 }
 
-
 # Adding a new string to a file.
 #
 # Arg #1: string
@@ -395,7 +441,6 @@ string_add()
     echo "${STRING}" >> ${FILE}
 }
 
-
 # Adding a new environment variable to a shadow password suite file (login.defs)
 #
 # Arg #1: variable name
@@ -421,8 +466,8 @@ var_add_shadow()
 
     # Checking if variable contains the new value
     if egrep "^${VARIABLE}" ${FILE} | grep "${VALUE}" 1> /dev/null 2>&1; then
-       echo "variable ${VARIABLE} already contains value: ${VALUE}"
-       exit 0
+       echo "${FUNCNAME}(), variable ${VARIABLE} already contains value: ${VALUE}"
+       return 0
     fi
 
     # Adding new value to variable
@@ -432,21 +477,25 @@ var_add_shadow()
     sed -i "s!\(^${VARIABLE}.*\)!\1:${VALUE}!" ${FILE}
 }
 
-
 # Adding a new group, checking if it already exist before.
 # Arguments: same arguments as for standard groupadd command.
 hv_groupadd()
 {
     arguments=${*}
 
+    set +e
+
     while [ $# -ne 0 ]; do
        last_argument=${*}
        shift
     done
     
     groupadd ${arguments}
+    error=$?
 
-    if [ $? -eq 0 -o $? -eq 9 ]; then
+    set -e
+
+    if [ ${error} -eq 0 -o ${error} -eq 9 ]; then
         # 9 means the group already exists
         return ${EXIT_SUCCESS}
     else
@@ -460,6 +509,8 @@ hv_useradd()
 {
     arguments="${*}"
 
+    set +e
+
     # The last argument is the username
     while [ $# -ne 0 ]; do
        last_argument=${*}
@@ -467,8 +518,11 @@ hv_useradd()
     done
 
     useradd ${arguments}
+    error=$?
 
-    if [ $? -eq 0 -o $? -eq 9 ]; then
+    set -e
+
+    if [ ${error} -eq 0 -o ${error} -eq 9 ]; then
         # 9 means the user already exists
         return ${EXIT_SUCCESS}
     else
@@ -476,50 +530,78 @@ hv_useradd()
     fi
 }
     
-
-# Evaluates the return value of the process that was run just before this
-# function was called.
-evaluate_retval()
-{
-    if [ $? -ne 0 ]; then
-       echo "*************"
-       echo "*   ERROR   *"
-       echo "*************"
-       exit 1
-    fi
-}
-
 # Evaluates the return value of the process that was run just before this
 # function was called.
-eval_retval2()
+eval_retval()
 {
     if [ $? -ne 0 ]; then
-        ${SET_CHECK_POSITION}
        print_status failure
-       echo
        exit ${EXIT_FAILURE}
     fi
 }
 
-
-
-
 # Obtain the name of the base directory for the decompressed package.
 # First argument: package name
 static_decompressed_dirname()
 {
     local PACKAGE=${1}
 
-    local DIRNAME=$(dirname $(tar -tf ${LFS_PKG_DIR}/${PACKAGE}.tar.bz2 | head -n1))
+    # List of default archive extensions to try
+    local MY_ARCH_EXT="tar.bz2 tar.gz tgz tar.Z zip"
+
+    for arch_ext in ${MY_ARCH_EXT}; do
+        if [ ! -f ${LFS_PKG_DIR}/${PACKAGE}.${arch_ext} ]; then
+            # Try next archive extension.
+            continue;
+        fi
+
+        case ${arch_ext} in
+           tar.bz2|tar.gz|tgz|tar.Z)
+                # Remove optional "./" leading component with sed
+                # and extract base directory name with awk.
+                # tar 1.23 reports an error when using pipes, so
+                # remove error message with "2> /dev/null"
+                local DIRNAME=$(tar ${TAR_OPTS} -tf ${LFS_PKG_DIR}/${PACKAGE}.tar.bz2 2> /dev/null | head -n1 | sed 's!^\./!!' | awk -F \/ '{print $1}')
+                echo ${DIRNAME}
+                ;;
+            zip)
+                # TODO
+                echo ${PACKAGE}
+                ;;
+        esac
+
+        return $?
+    done
+
+    # Failure or file not found
+    echo "${FUNCNAME}(): Missing source package for \"${PACKAGE}\"" > /dev/stderr
+    return ${EXIT_FAILURE}
+}
+
+# Applying patch
+# First argument is the name of the patch
+# Second argument is the package name (target dir in $LFS_TMP)
+apply_patch()
+{
+    local PATCH_FILE=${1}
+    local TARGET_DIR=${2}
+
+    if [ -z "${PATCH_FILE}" ]; then
+        echo
+       echo "apply_patch(): no patch specified."
+       return ${EXIT_FAILURE}
+    fi
 
-    if [ "x${DIRNAME}" == "x." ]; then
-        DIRNAME=$(basename $(tar -tf ${LFS_PKG_DIR}/${PACKAGE}.tar.bz2 | head -n1))
+    if [ ! -f ${LFS_PKG_DIR}/${PATCH_FILE} ]; then
+        echo
+       echo "${FUNCNAME}(): patch file '${PATCH_FILE}' not found."
+       return ${EXIT_FAILURE}
     fi
 
-    echo ${DIRNAME}
+    echo "Applying patch: ${PATCH_FILE}"
+    patch -Np1 -d ${LFS_TMP}/${TARGET_DIR} -i ${LFS_PKG_DIR}/${PATCH_FILE}
 }
 
-
 # Applying any patch(es) found for the current package.
 # Will work only if patches have the same base name as
 # the package, followed by a dash:
@@ -542,51 +624,20 @@ apply_patches()
     if [ $# -eq 2 ]; then
        TARGET_DIR=${2}
     else
-       TARGET_DIR=$(static_decompressed_dirname ${PACKAGE})
+       TARGET_DIR=${PACKAGE}
     fi
     
     # Checking if we can find at least one patch.
     if ls ${LFS_PKG_DIR}/${1}-*.patch 1> /dev/null 2>&1; then
        cd ${LFS_PKG_DIR}
        for patch in ${1}-*.patch; do
-           echo "******************************"
-           echo "* Applying patch: ${patch}"
-           echo "******************************"
-           patch -Np1 -d ${LFS_TMP}/${TARGET_DIR} -i ${LFS_PKG_DIR}/${patch} || exit 1
+            apply_patch ${patch} ${TARGET_DIR} || exit 1
        done
     fi
 
     return $?
 }
 
-
-# Applying patch
-# First argument is the name of the patch
-# Second argument is the package name
-apply_patch()
-{
-    PATCH_FILE=${1}
-    PACKAGE=${2}
-
-    if [ -z "${PATCH_FILE}" ]; then
-        echo
-       echo "apply_patch(): no patch specified."
-       return ${EXIT_FAILURE}
-    fi
-
-    if [ ! -f ${LFS_PKG_DIR}/${PATCH_FILE} ]; then
-        echo
-       echo "${FUNCNAME}(): patch file '${PATCH_FILE}' not found."
-       return ${EXIT_FAILURE}
-    fi
-
-    echo "******************************"
-    echo "* Applying patch: ${PATCH_FILE}"
-    echo "******************************"
-    patch -Np1 -d ${LFS_TMP}/${PACKAGE} -i ${LFS_PKG_DIR}/${PATCH_FILE}
-}
-
-
 # Decompression of a package
 # First argument: package name
 # Second argument: directory where decompressing (optional)
@@ -598,411 +649,311 @@ decompress_package()
     elif [ $# -eq 2 ]; then
        local TOPDIR=${2}
     else
-       echo
-       echo "${FUNCNAME}(): Incorrect number of arguments (must be 1 or 2)"
+       echo "${FUNCNAME}(): Incorrect number of arguments (must be 1 or 2)" > /dev/stderr
        return ${EXIT_FAILURE}
     fi
 
     local PACKAGE=${1}
 
-    if [ ! -f ${LFS_PKG_DIR}/${PACKAGE}.tar.bz2 ]; then
-       echo "${FUNCNAME}(): Missing source package: \"${PACKAGE}.tar.bz2\""
-       return ${EXIT_FAILURE}
-    fi
-    
-    local DECOMPRESSED_DIRNAME=$(static_decompressed_dirname ${PACKAGE})
-
-    if [ -d ${TOPDIR}/${DECOMPRESSED_DIRNAME} ]; then
-       # Removing old source directory (if any)
-       rm -v -rf ${TOPDIR}/${DECOMPRESSED_DIRNAME} || exit 1
-    fi
+    # List of default archive extensions to try
+    local MY_ARCH_EXT="tar.bz2 tar.gz tgz tar.Z zip"
+
+    for arch_ext in ${MY_ARCH_EXT}; do
+        if [ ! -f ${LFS_PKG_DIR}/${PACKAGE}.${arch_ext} ]; then
+            # Try next archive extension.
+            continue;
+        fi
+
+        if [ -d ${TOPDIR}/${PACKAGE} ]; then
+            # Removing old source directory (if any)
+           rm -v -rf ${TOPDIR}/${PACKAGE} || exit 1
+        fi
+
+        cd ${TOPDIR}
+
+        # Decompressing package
+        case ${arch_ext} in
+           tar.bz2)
+                tar ${TAR_OPTS} -jxvf ${LFS_PKG_DIR}/${PACKAGE}.${arch_ext} || return 1
+                ;;
+           tar.gz|tgz|tar.Z)
+                tar ${TAR_OPTS} -zxvf ${LFS_PKG_DIR}/${PACKAGE}.${arch_ext} || return 1
+                ;;
+            zip)
+                echo ZIPZIPZIP
+                unzip ${LFS_PKG_DIR}/${PACKAGE}.${arch_ext} || return 1
+                ;;
+        esac
+
+        cd - 1> /dev/null 2>&1
+
+        return $?
+    done
 
-    # Decompressing package
-    # Option 'U' of tar is to remove each file prior to extracting over it
-    cd ${TOPDIR} &&
-    tar -jxvf ${LFS_PKG_DIR}/${PACKAGE}.tar.bz2 &&
-    cd - 1> /dev/null 2>&1
+    # Failure or file not found
+    echo "${FUNCNAME}(): Missing source package for \"${PACKAGE}\"" > /dev/stderr
+    return ${EXIT_FAILURE}
 }
 
-
-# Installation of a package, removing source and build directories after.
-#
-# First argument:  package name
-# Second argument: script name
-# Remaining arguments: additional configure options
+# Installation of a package
+# Arg. #1: Package name and version (ex: gcc-4.5.1)
+# Remaining arguments: Additional configure options
+# Options:
+#   -h     Display this help and returns
+#   -l     Unique identification label in 'install.log'
+#          (default is package name and version)
+#   -m     Installation mode:
+#            ac   Standard autoconf package, build in separate dir
+#            acnb Standard autoconf package, building in source dir
+#            nb   No autoconf (configure)
+#            gnome
+#            xorg
+#            pm
+#   -s     Name of script to execute (default is ipkg.sh)
 ipkg()
 {
-    # Checking for correct number of arguments
-    if [ $# -ne 2 ]; then
-        echo
-       echo "${FUNCNAME}(): Wrong number of arguments"
-       echo "  command was: \"${FUNCNAME}() $*\""
-       exit ${EXIT_FAILURE}
-    fi
-
-    static_ipkg ${1} ${2} ${1}
-}
-
+    START_TIME=$(echo `date +%s`)
 
-# Installation of a package conforming to GNU autotools.
-# The package must be able to be built outside the
-# source directory.
-#
-# First argument:      package name
-# Remaining arguments: additional configure options
-ipkg_ac()
-{
-    # Checking for correct number of arguments
-    if [ $# -lt 1 ]; then
-        echo
-       echo "${FUNCNAME}(): Wrong number of arguments"
-       echo "  command was: \"${FUNCNAME}() $*\""
-       exit ${EXIT_FAILURE}
-    fi
+    export IPKG_MODE="ac"
+    export HVLABEL="" # Global variable
+    local SCRIPT=./ipkg.sh
+
+    while getopts "hl:m:" flag ;do
+        case ${flag} in
+           l)
+                # Alternate label
+                HVLABEL=${OPTARG}
+               ;;
+           m)
+                # Installation mode
+                case ${OPTARG} in
+                   ac|acnb|noac|gnome|xorg|pm)
+                        IPKG_MODE=${OPTARG}
+                       ;;
+                    *)
+                       echo "${FUNCNAME}(): Unsupported mode: ${OPTARG}."
+                       return 1
+                        ;;
+                esac
+                ;;
+           s)
+                # Alternate script name
+                SCRIPT=${OPTARG}
+               ;;
+           ?)
+               echo "${FUNCNAME}(): Invalid option: ${OPTARG}."
+               return 1
+               ;;
+        esac
+    done
+    shift `expr "${OPTIND}" - 1`
 
-    local PACKAGE=${1}
-    shift
-    local CONFIGURE_OPTS=${*}
-
-    static_ipkg ${PACKAGE} cis-ac ${PACKAGE} ${CONFIGURE_OPTS}
-}
+    unset OPTSTRING
+    unset OPTIND
+    unset OPTARG
 
+    local PACKAGE_NAME=${1}
 
-# Installation of a package conforming to GNU autotools,
-# but that must be built inside the source directory.
-#
-# First argument:      package name
-# Remaining arguments: additional configure options
-ipkg_ac_nb()
-{
     # Checking for correct number of arguments
     if [ $# -lt 1 ]; then
         echo
-       echo "${FUNCNAME}(): Wrong number of arguments"
+       echo "${FUNCNAME}(): Missing argument"
        echo "  command was: \"${FUNCNAME}() $*\""
        exit ${EXIT_FAILURE}
     fi
 
-    local PACKAGE=${1}
     shift
     local CONFIGURE_OPTS=${*}
 
-    static_ipkg ${PACKAGE} cis-ac-nobuild ${PACKAGE} ${CONFIGURE_OPTS}
-}
-
-
-# Installation of a GNOME package.
-#
-# First argument:  package name
-ipkg_gnome()
-{
-    # Checking for correct number of arguments
-    if [ $# -ne 1 ]; then
-        echo
-       echo "${FUNCNAME}(): Wrong number of arguments"
-       echo "  command was: \"${FUNCNAME}() $*\""
-       exit ${EXIT_FAILURE}
-    fi
-
-    static_ipkg ${1} cis-gnome ${1}
-}
-
-
-# Installation of a PERL module
-#
-# First argument:  package name
-ipkg_pm()
-{
-    # Checking for correct number of arguments
-    if [ $# -ne 1 ]; then
-        echo
-       echo "${FUNCNAME}(): Wrong number of arguments"
-       echo "  command was: \"${FUNCNAME}() $*\""
-       exit ${EXIT_FAILURE}
-    fi
-
-    static_ipkg ${1} cis-pm ${1}
-}
-
-
-# Multiple installation of a package. This is usefull for packages
-# that may need to be installed multiple times, at different
-# times of the build process, like for GCC pas 1 and GCC pass 2.
-#
-# First argument:  Real package name
-# Second argument: Installation script name
-# Third argument:  Unique identification label in 'install.log'
-ipkg_mult()
-{
-    # Checking for correct number of arguments
-    if [ $# -ne 3 ]; then
-        echo
-       echo "${FUNCNAME}(): Wrong number of arguments"
-       echo "  command was: \"${FUNCNAME}() $*\""
-       exit ${EXIT_FAILURE}
-    fi
-
-    static_ipkg ${1} ${2} ${3}
-}
-
-
-# Installation of a package
-#
-# First argument:      Real package name
-# Second argument:     Installation script name
-# Third argument:      Unique identification label in 'install.log'
-# Remaining arguments: Additional configure options
-static_ipkg()
-{
-    local START_TIME=$(echo `date +%s`)
-    local PACKAGE_NAME=${1}
-    local SCRIPT=./${2}
-    local LABEL=${3}
-    # Checking for correct number of arguments
-    if [ $# -lt 3 ]; then
-        echo
-       echo "${FUNCNAME}(): Missing argument"
-       echo "  command was: \"${FUNCNAME}() $*\""
-       exit ${EXIT_FAILURE}
+    if [ -z "${HVLABEL}" ]; then
+        # Default label = package name and version
+        HVLABEL=${PACKAGE_NAME}
     fi
 
-    shift
-    shift
-    shift
-    local CONFIGURE_OPTS=${*}
-
     # Checking if script is valid and executable
     if [ ! -x ${SCRIPT} ]; then
         echo
-       echo "${FUNCNAME}(): script not found: ${SCRIPT}"
+       echo "${FUNCNAME}(): cannot execute script: ${SCRIPT}"
        exit ${EXIT_FAILURE}
     fi
 
-    PACKAGE_LOG=${LFS_LOG_DIR}/${PACKAGE_NAME}.log
+    PACKAGE_LOG=${LFS_LOG_DIR}/${HVLABEL}.log
 
     # Checking if package was previously successfully installed
-    if grep "^${LABEL} successfully installed" ${LFS_LOG_FILE} \
+    if grep "^${HVLABEL} successfully installed" ${LFS_LOG_FILE} \
       1> /dev/null 2>&1; then
        return $EXIT_SUCCESS
     fi
     
     # Displaying label
-    echo -n "[ ] Installing" ${LABEL}" "
+    MSGSTRING="Installing ${HVLABEL}"
+    display_checkbox_msg ${MSGSTRING}
 
     echo "------------------------" 1>> ${LFS_LOG_FILE}
-    echo "Installing" ${LABEL} 1>> ${LFS_LOG_FILE}
+    echo "${MSGSTRING}" 1>> ${LFS_LOG_FILE}
 
-    decompress_package ${PACKAGE_NAME} 1>> ${PACKAGE_LOG} 2>&1
-    eval_retval2
+    echo "Decompressing package" 1>> ${PACKAGE_LOG} 2>&1 &&
+    decompress_package ${PACKAGE_NAME} 1> /dev/null 2>> ${PACKAGE_LOG}
+    eval_retval
 
-    # Get the name of the decompressed directory
     local DECOMPRESSED_DIRNAME=$(static_decompressed_dirname ${PACKAGE_NAME})
 
+    # Rename the decompressed package as per the package name if necessary
+    if [ "x${DECOMPRESSED_DIRNAME}" != "x${PACKAGE_NAME}" ]; then
+        mv ${LFS_TMP}/${DECOMPRESSED_DIRNAME} ${LFS_TMP}/${PACKAGE_NAME}
+        eval_retval
+    fi
+
     # Displaying package source size in log file
-    echo "  Source size:" $(du -h -s ${LFS_TMP}/${DECOMPRESSED_DIRNAME} | awk '{ print $1 }') 1>> ${LFS_LOG_FILE}
+    echo "  Source size:" $(du -h -s ${LFS_TMP}/${PACKAGE_NAME} | awk '{ print $1 }') 1>> ${LFS_LOG_FILE}
 
     # Removing old build directory (if any)
     if [ -d ${LFS_TMP}/${PACKAGE_NAME}-build ]; then
-       rm -v -rf ${LFS_TMP}/${PACKAGE_NAME}-build 1>> ${PACKAGE_LOG} 2>&1
-        eval_retval2
+        echo "Removing old build directory" 1>> ${PACKAGE_LOG} 2>&1 &&
+       rm -v -rf ${LFS_TMP}/${PACKAGE_NAME}-build 1> /dev/null 2>> ${PACKAGE_LOG}
+        eval_retval
     fi
 
     # Creating build directory
     mkdir -v ${LFS_TMP}/${PACKAGE_NAME}-build 1>> ${PACKAGE_LOG} 2>&1
-    eval_retval2
+    eval_retval
 
     # Executing script.
     ${SCRIPT} ${PACKAGE_NAME} ${CONFIGURE_OPTS} 1>> ${PACKAGE_LOG} 2>&1
-    eval_retval2
+    eval_retval
 
     # Displaying package build size in log file
-    BUILD_SIZE=$(du -h -s -c ${LFS_TMP}/${DECOMPRESSED_DIRNAME} ${LFS_TMP}/${PACKAGE_NAME}-build | grep total | awk '{ print $1 }')
+    BUILD_SIZE=$(du -h -s -c ${LFS_TMP}/${PACKAGE_NAME} ${LFS_TMP}/${PACKAGE_NAME}-build | grep total | awk '{ print $1 }')
     echo "  Build size : ${BUILD_SIZE}" 1>> ${LFS_LOG_FILE}
 
     # Some scripts need to preserve the source or build directory. They can
     # do so by renaming them.
-    if [ -d ${LFS_TMP}/${DECOMPRESSED_DIRNAME} ]; then
+    if [ -d ${LFS_TMP}/${PACKAGE_NAME} ]; then
        # Removing source directory
-       rm -v -rf ${LFS_TMP}/${DECOMPRESSED_DIRNAME} 1>> ${PACKAGE_LOG} 2>&1
-        eval_retval2
+        echo "Removing source directory" 1>> ${PACKAGE_LOG} 2>&1 &&
+       rm -v -rf ${LFS_TMP}/${PACKAGE_NAME} 1> /dev/null 2>> ${PACKAGE_LOG}
+        eval_retval
     fi
     if [ -d ${LFS_TMP}/${PACKAGE_NAME}-build ]; then
        # Removing build directory
-       rm -v -rf ${LFS_TMP}/${PACKAGE_NAME}-build 1>> ${PACKAGE_LOG} 2>&1
-        eval_retval2
+        echo "Removing build directory" 1>> ${PACKAGE_LOG} 2>&1 &&
+       rm -v -rf ${LFS_TMP}/${PACKAGE_NAME}-build 1> /dev/null 2>> ${PACKAGE_LOG}
+        eval_retval
     fi
 
     # Writing success string to the end of the log file
-    echo "${LABEL} successfully installed" 1>> ${LFS_LOG_FILE}
+    echo "${HVLABEL} successfully installed" 1>> ${LFS_LOG_FILE}
 
     # Displaying build time after the package name
-    display_build_time ${START_TIME}
-
-    ${SET_CHECK_POSITION}
     print_status success
 
     return $EXIT_SUCCESS
 }
 
-
-# Display the action name, run a command, log its output and display it's
-# status
-# First argument: action name (string)
-# Remaining arguments: command name with it's options
-action_checkbox()
+# Run command, no log
+# First  argument: Message to display during script
+# Second argument: command + arguments
+rcmd()
 {
-    # Displaying script name
-    echo -n "[ ]" $1
-    $SET_CHECK_POSITION
-    shift
-    echo $* 1>> ${LFS_LOG_FILE}
+    START_TIME=$(echo `date +%s`)
 
-    # Executing command
-    $* 1>> ${LFS_LOG_FILE} 2>&1
-    if [ $? -ne 0 ]; then
-       print_status failure
-       echo
+    # Checking for correct number of arguments
+    if [ $# -lt 2 ]; then
+       echo "${FUNCNAME}(): Missing argument(s)"
        exit ${EXIT_FAILURE}
     fi
 
-    print_status success
-
-    return $EXIT_SUCCESS
-}
-
-
-# Display the action name, run a command, log its output and display it's
-# status and the time it took to execute.
-# Note: In case of errors, this function returns an error code instead
-#       of exiting.
-# First argument: action name (string)
-# Remaining arguments: command name with it's options
-action_checkbox_time()
-{
-    START_TIME=$(echo `date +%s`)
-
-    # Displaying script name
-    echo -n "[ ]" $1" "
+    local MSGSTRING=${1}
+    local CMD=${2}
     shift
-    echo $* 1>> ${LFS_LOG_FILE}
+    local CMD_WITH_ARGS=${*}
+
+    display_checkbox_msg ${MSGSTRING}
+    echo ${CMD_WITH_ARGS} 1>> ${LFS_LOG_FILE}
 
     # Executing command
-    $* 1>> ${LFS_LOG_FILE} 2>&1
+    ${CMD_WITH_ARGS} 1>> ${LFS_LOG_FILE} 2>&1
     if [ $? -ne 0 ]; then
-       ${SET_CHECK_POSITION}
        print_status failure
-
-       return ${EXIT_FAILURE}
-    else
-       # Displaying build time after the package name
-       display_build_time ${START_TIME}
-       
-       ${SET_CHECK_POSITION}
-       print_status success
-       
-       return $EXIT_SUCCESS
+        if [ -n "${RCMD_NO_EXIT}" ]; then
+            return ${EXIT_FAILURE}
+        else
+           exit ${EXIT_FAILURE}
+        fi
     fi
-}
 
+    # Displaying build time after the package name
+    print_status success
+
+    return $EXIT_SUCCESS
+}
 
 # Display the action name, run a command, log its output and display it's
 # status. Write to install log file when successfully completed so it
 # won't be called again after a successfull installation.
-# First argument:  label (string)
-# Second argument: script name
-run_script_log()
+
+# First  argument: "once" -> script is run only once
+#                  "mult" -> script can be run more than once
+# Second argument: Message to display during script
+# Third  argument: script name (will be label)
+rscr()
 {
-    LABEL=${1}
-    SCRIPT=${2}
+    START_TIME=$(echo `date +%s`)
 
     # Checking for correct number of arguments
-    if [ $# -lt 2 ]; then
-       echo "${FUNCNAME}(): Missing argument"
+    if [ $# -lt 3 ]; then
+       echo "${FUNCNAME}(): Missing argument(s)"
        exit ${EXIT_FAILURE}
     fi
 
+    SCRMODE=${1}
+    MSGSTRING=${2}
+    SCRIPT=${3}
+    HVLABEL=${SCRIPT}
     shift
     shift
     SCRIPT_ARGS=${*}
 
+    # Checking script mode:
+    if [ "x${SCRMODE}" != "xonce" -a "x${SCRMODE}" != "xmult" ]; then
+       echo "${FUNCNAME}(): First argument invalid, must be \"once\" or \"mult\" (\"${SCRMODE}\" given)"
+       exit ${EXIT_FAILURE}
+    fi
+
     # Checking if script is valid and executable
     if [ ! -x ./${SCRIPT} ]; then
        echo "${FUNCNAME}(): script not found: ${SCRIPT}"
        exit ${EXIT_FAILURE}
     fi
 
-    PACKAGE_LOG=${LFS_LOG_DIR}/${LABEL}.log
+    PACKAGE_LOG=${LFS_LOG_DIR}/${HVLABEL}.log
 
-    # Checking if package was previously successfully installed
-    if grep "^${LABEL} successfully installed" ${LFS_LOG_FILE} 1> /dev/null 2>&1;
-       then
-       return $EXIT_SUCCESS
+    if [ "x${SCRMODE}" = "xonce" ]; then
+        # Checking if package was previously successfully installed
+        if grep "^${HVLABEL} successfully installed" ${LFS_LOG_FILE} 1> /dev/null 2>&1; then
+           return $EXIT_SUCCESS
+        fi
     fi
-    
-    # Displaying script name
-    echo -n "[ ] ${LABEL}"
+
+    display_checkbox_msg ${MSGSTRING}
     echo "------------------------" 1>> ${LFS_LOG_FILE}
-    echo "Running " ${LABEL} 1>> ${LFS_LOG_FILE}
-    echo 1>> ${LFS_LOG_FILE}
+    echo ${HVLABEL} 1>> ${LFS_LOG_FILE}
 
-    # Executing command
+    # Executing script
     ./${SCRIPT} ${SCRIPT_ARGS} 1>> ${PACKAGE_LOG} 2>&1
-    eval_retval2
-
-    # Writing success string to the end of the log file
-    echo "${LABEL} successfully installed" 1>> ${LFS_LOG_FILE}
-
-    $SET_CHECK_POSITION
-    print_status success
-
-    return $EXIT_SUCCESS
-}
-
+    eval_retval
 
-# Display the action name, run a command, log its output and display it's
-# status. Write to install log file when successfully completed so it
-# won't be called again after a successfull installation.
-# First argument:  label (string)
-# Second argument: script name
-run_cmd_log()
-{
-    # Checking for correct number of arguments
-    if [ $# -lt 2 ]; then
-       echo "${FUNCNAME}(): Missing argument"
-       exit ${EXIT_FAILURE}
+    if [ "x${SCRMODE}" = "xonce" ]; then
+        # Writing success string to the end of the log file
+        echo "${HVLABEL} successfully installed" 1>> ${LFS_LOG_FILE}
     fi
 
-    LABEL=${1}
-    shift
-    SCRIPT=${*}
-
-    # Checking if package was previously successfully installed
-    if grep "^${LABEL} successfully installed" ${LFS_LOG_FILE} 1> /dev/null 2>&1;
-       then
-       return $EXIT_SUCCESS
-    fi
-    
-    # Displaying script name
-    echo -n "[ ] ${LABEL}"
-    echo "------------------------" 1>> ${LFS_LOG_FILE}
-    echo "${LABEL}" 1>> ${LFS_LOG_FILE}
-    echo 1>> ${LFS_LOG_FILE}
-
-    # Executing command
-    ${SCRIPT} 1>> ${LFS_LOG_FILE} 2>&1
-    eval_retval2
-
-    # Writing success string to the end of the log file
-    echo "${LABEL} successfully installed" 1>> ${LFS_LOG_FILE}
-
-    $SET_CHECK_POSITION
+    # Displaying build time after the package name
     print_status success
 
     return $EXIT_SUCCESS
 }
 
-
 get_total_build_time()
 {
     INFILE=${1}
@@ -1030,13 +981,13 @@ get_total_build_time()
     echo "${HOURS}.${MIN}"
 }
 
-
+# Global variable: START_TIME
 display_build_time()
 {
     END_TIME=$(echo `date +%s`)
 
     HOURS=$(( ( ${END_TIME} - ${START_TIME} ) / 3600 ))
-    echo -n "("${HOURS}"."
+    echo -n " ("${HOURS}"."
     echo -n "  Build time: ${HOURS}." 1>> ${LFS_LOG_FILE}
 
     # Time is inferior to 1 hour...
@@ -1059,50 +1010,51 @@ display_build_time()
     echo "h" 1>> ${LFS_LOG_FILE}
 }
 
+# Global variable: MSGSTRING
+display_checkbox_msg()
+{
+    echo -en "${BRACKET}[ ${BRACKET}]${NORMAL} ${MSGSTRING}"
+}
 
 # The print_status prints a coloured "X" letter inside the checkbox to the left
-# of the screen (the checkbox is displayed with the action_checkbox function).
+# of the screen (the checkbox is already displayed, and the cursor must have
+# been saved to where to put the mark).
+# 1st arg: status: success, warning or failure
+# Global variables: MSGSTRING and START_TIME
 print_status()
 {
-    if [ $# = 0 ]; then
+    if [ $# -ne 1 ]; then
         # If no parameters are given to the print_status function, print usage
         # information.
-       echo "Usage: ${FUNCNAME}() {success|warning|failure}"
+       echo "Usage: ${FUNCNAME}() {success|warning|failure} [STRING] [TIME]"
        return ${EXIT_FAILURE}
     fi
-    
-    case "$1" in
+
+    local COLOR=""
+
+    case "${1}" in
        success)
-           $SUCCESS
+           COLOR=$SUCCESS
            ;;
        warning)
-           $WARNING
+           COLOR=$WARNING
            ;;
        failure)
-           $FAILURE
+           COLOR=$FAILURE
            ;;
        *)
            echo "Usage: ${FUNCNAME}() {success|warning|failure}"
            return ${EXIT_FAILURE}
            ;;
     esac
-    echo "X"
-    $NORMAL 
-}
-
 
-# Testing GCC toolchain
-gcc_toolchain_test_stage1()
-{
-    cd ${LFS_TMP} &&
-    echo 'main(){}' > dummy.c &&
-    cc dummy.c &&
-    readelf -l a.out | grep ': /tools' 1> /dev/null 2>&1
+    # Reposition cursor at start of line
+    echo -en "${SET_CURSOR_START_LINE}"
+    echo -en "${BRACKET}[${COLOR}X${BRACKET}]${NORMAL} ${MSGSTRING}"
 
-    if [ $? -ne 0 ]; then
-        echo "Testing toolchain failed..."
-        exit 1
+    if [ "x${MSGSTRING}" != "x" ]; then
+        display_build_time
     fi
 
-    rm dummy.c a.out
+    echo
 }